



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>设计模式NO.2</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">设计模式NO.2</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 09:48:04 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>设计模式NO.2</h1>
<p>本次博客内容为第二次设计模式的练习。根据老师的要求完成下列题目：</p>
<h4>题目1</h4>
<p>如果需要开发一个跨平台视频播放器，可以在不同操作系统平台（如Windows、Linux、UNIX等）上播放多种格式的视频文件，常见的视频格式包括MPEG、RMVB、AVI、WMV等。使用Bridge模式来设计。<br /><br />
<strong>类图设计如下：</strong><br /><br />
<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1249114/201711/1249114-20171110160118419-1110854733.png"></p>
<p><strong>代码实现如下：</strong><br /><br />
a.视频格式抽象类</p>
<pre class="prettyprint linenums"><code>public abstract class Form {

	public abstract void playForm(String os);

}<br />
</code></pre>
<p>b.AVI视频格式类</p>
<pre class="prettyprint linenums"><code>public class AVI extends Form{

	@Override<br />
	public void playForm(String os) {<br />
		System.out.println(&quot;the form of video is AVI. OS version is &quot;+os);

	}

}<br />
</code></pre>
<p>c.MPEG视频格式类</p>
<pre class="prettyprint linenums"><code>public class MPEG extends Form{

	@Override<br />
	public void playForm(String os) {<br />
		System.out.println(&quot;the form of video is MPEG. OS version is &quot;+os);

	}

}<br />
</code></pre>
<p>d.RMVB视频格式类</p>
<pre class="prettyprint linenums"><code>public class RMVB extends Form{

	@Override<br />
	public void playForm(String os) {<br />
		System.out.println(&quot;the form of video is RMVB. OS version is &quot;+os);

	}

}<br />
</code></pre>
<p>e.WAV视频格式类</p>
<pre class="prettyprint linenums"><code>public class WAV extends Form{

	@Override<br />
	public void playForm(String os) {<br />
		System.out.println(&quot;the form of video is WAV. OS version is &quot;+os);

	}<br />
}<br />
</code></pre>
<p>f.操作系统抽象类</p>
<pre class="prettyprint linenums"><code>public abstract class OS {<br />
	protected Form m_form;<br />
	public void setForm(Form form)<br />
	{<br />
		m_form=form;<br />
	}<br />
	public abstract void play();

}<br />
</code></pre>
<p>g.Windows系统类</p>
<pre class="prettyprint linenums"><code>public class Windows extends OS{

	@Override<br />
	public void play() {<br />
		m_form.playForm(&quot;Windows&quot;);

	}

}<br />
</code></pre>
<p>h.Linux系统类</p>
<pre class="prettyprint linenums"><code>public class Linux extends OS{

	@Override<br />
	public void play() {<br />
		m_form.playForm(&quot;Linux&quot;);<br />
	}<br />
}<br />
</code></pre>
<p>i.UNIX系统类</p>
<pre class="prettyprint linenums"><code>public class UNIX extends OS{

	@Override<br />
	public void play() {<br />
		m_form.playForm(&quot;UNIX&quot;);

	}<br />
}<br />
</code></pre>
<p>j.测试代码</p>
<pre class="prettyprint linenums"><code>	public static void main(String[] args) {<br />
		Form form = new RMVB();<br />
		OS os = new Windows();<br />
		os.setForm(form);<br />
		os.play();//the form of video is RMVB. OS version is Windows

		form = new AVI();<br />
		os = new Linux();<br />
		os.setForm(form);<br />
		os.play();//the form of video is AVI. OS version is Linux<br />
	}<br />
</code></pre>
<h4>Bridge模式小结</h4>
<p>a.优点<br /><br />
桥接模式将抽象部分与它的实现部分分离开来，使他们都可以独立变化。 桥接模式将继承关系转化成关联关系，它降低了类与类之间的耦合度，减少了系统中类的数量，也减少了代码量。<br /><br />
b.适用场景</p>
<ul><li>如果一个系统需要在构件的抽象化角色和具体化角色之间增加更多的灵活性，避免在两个层次之间建立静态的继承联系，通过桥接模式可以使它们在抽象层建立一个关联关系。</li>
<li>对于那些不希望使用继承或因为多层次继承导致系统类的个数急剧增加的系统，桥接模式尤为适用。</li>
<li>一个类存在两个独立变化的维度，且这两个维度都需要进行扩展。</li></ul>
<h4>题目2</h4>
<p>杀毒软件（AntiVirus）既能对系统中不同类型的文件 TextFile、ImageFile、VideoFile杀毒，也能对文件夹的杀毒，对文件夹杀毒就是对其中所包含文件的杀毒。使用Composite模式来设计。<br /><br />
类图设计如下：<br /><br />
<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1249114/201711/1249114-20171110164053028-1676718098.png"><br /><br />
<strong>代码实现如下：</strong><br /><br />
a.抽象文件类</p>
<pre class="prettyprint linenums"><code>public abstract class Files {<br />
	public abstract void antiVirus();<br />
}<br />
</code></pre>
<p>b.TextFile类</p>
<pre class="prettyprint linenums"><code>public class TextFile extends Files<br />
{

	@Override<br />
	public void antiVirus() {<br />
		System.out.println(&quot;TextFile is antivirusing!&quot;);

	}

}<br />
</code></pre>
<p>c.ImageFile类</p>
<pre class="prettyprint linenums"><code>public class ImageFile extends Files{

	@Override<br />
	public void antiVirus() {<br />
		System.out.println(&quot;ImageFile is antivirusing!&quot;);

	}

}<br />
</code></pre>
<p>d.VideoFile类</p>
<pre class="prettyprint linenums"><code>public class VideoFile extends Files{

	@Override<br />
	public void antiVirus() {<br />
		System.out.println(&quot;VideoFile is antivirusing&quot;);

	}

}<br />
</code></pre>
<p>e.FolderFile类</p>
<pre class="prettyprint linenums"><code>import java.util.ArrayList;

public class FloderFile extends Files{<br />
	private ArrayList&lt;Files&gt; m_files=new ArrayList&lt;Files&gt;();

	@Override<br />
	public void antiVirus() {<br />
		System.out.println(&quot;folder is antivirusing!&quot;);<br />
		for(Files file:m_files)<br />
		{<br />
			file.antiVirus();<br />
		}

	}<br />
	public void addFile(Files file)<br />
	{<br />
		m_files.add(file);<br />
	}<br />
	public void deleteFile(Files file)<br />
	{<br />
		m_files.remove(file);<br />
	}

}<br />
</code></pre>
<p>f.AntiVirus类(测试类)</p>
<pre class="prettyprint linenums"><code>public class AntiVirus {<br />
	public static void main(String[] args) {<br />
		Files file = new VideoFile();<br />
		file.antiVirus();//VideoFile is antivirusing

		Files file2 = new TextFile();<br />
		file2.antiVirus();//TextFile is antivirusing!

		FloderFile files = new FloderFile();<br />
		files.addFile(file);<br />
		files.addFile(file2);<br />
		files.antiVirus();<br />
		//folder is antivirusing!<br />
		//VideoFile is antivirusing<br />
		//TextFile is antivirusing!<br />
	}

}<br />
</code></pre>
<h4>Composite模式小结</h4>
<p>Composite模式有两种形态：透明形态和安全形态。本文是使用安全形态实现的。<br /><br />
a.优点<br /><br />
Composite模式 定义了包含基本对象和组合对象的类层次结构，这不仅可以简化客户代码，而且使得更容易增加新类型的组件、设计变得更加一般化。<br /><br />
b.适用场景</p>
<ul><li>将对象组合成树形结构以表示 “部分-整体” 的层次结构。</li>
<li>使得用户对于单个对象和组合对象的使用具有一致性。</li></ul>
<h4>题目3</h4>
<p>某系统提供一个数据加密功能，可以对字符串进行加密。最简单的加密算法通过对字母进行移位来实现，同时还提供稍复杂的逆向输出加密，还提供更为高级的求模加密。用户首先使用最简单的加密算法对字符串进行加密，如果觉得还不够可以对加密后的结果使用其他的加密算法进行二次加密，当然也可以进行第三次加密。使用Decrator模式来设计。<br /><br />
<strong>类图设计如下：</strong><br /><br />
<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1249114/201711/1249114-20171110183012825-520303546.png"><br /><br />
<strong>代码实现如下：</strong><br /><br />
a.抽象加密接口</p>
<pre class="prettyprint linenums"><code>public interface Encryption {<br />
	public void encrypt();<br />
}<br />
</code></pre>
<p>b.字母移位加密类</p>
<pre class="prettyprint linenums"><code>public class ShiftEncryption implements Encryption{<br />
	@Override<br />
	public void encrypt() {<br />
		System.out.println(&quot;ShiftEncryption&quot;);<br />
	}<br />
}<br />
</code></pre>
<p>c.逆向输出加密类</p>
<pre class="prettyprint linenums"><code>public class ConverseEncryption extends Decrator{

	public ConverseEncryption(Encryption enc) {<br />
		super(enc);<br />
	}<br />
	public void encrypt() {<br />
		m_way.encrypt();<br />
		System.out.println(&quot;ConverseEncryption&quot;);

	}<br />
}<br />
</code></pre>
<p>d.求模加密类</p>
<pre class="prettyprint linenums"><code>public class ModEncryption extends Decrator{

	public ModEncryption(Encryption enc) {<br />
		super(enc);<br />
	}<br />
	public void encrypt() {<br />
		m_way.encrypt();<br />
		System.out.println(&quot;ModEncryption&quot;);

	}

}<br />
</code></pre>
<p>e. Decrator类</p>
<pre class="prettyprint linenums"><code>public class Decrator implements Encryption{<br />
	protected Encryption m_way;<br />
	public Decrator(Encryption enc) {<br />
		m_way=enc;<br />
	}

	@Override<br />
	public void encrypt() {<br />
		m_way.encrypt();

	}

}<br />
</code></pre>
<p>f.测试类</p>
<pre class="prettyprint linenums"><code>public class test {

	public static void main(String[] args) {<br />
		Encryption enc = new ShiftEncryption();<br />
		enc = new ModEncryption(enc);<br />
		enc = new ConverseEncryption(enc);<br />
		enc = new ModEncryption(enc);<br />
		enc.encrypt();<br />
		//ShiftEncryption<br />
		//ModEncryption<br />
		//ConverseEncryption<br />
		//ModEncryption<br />
	}

}<br />
</code></pre>
<h4>Decrator模式小结</h4>
<p>Decrator模式有透明和半透明两种形态。透明形态是指：装饰者不改变接口类型。半透明形态是指：装饰者改变接口类型，增加新的方法。<br /><br />
本文使用的是透明形态的Decrator模式。<br /><br />
a.优点<br /><br />
装饰模式可以在不改变接口的前提下动态地增强所考虑的类的性能。通过使用不同的具体装饰类以及这些装饰类的排列组合，设计师可以创造出很多不同行为的组合。<br /><br />
b.适用场景</p>
<ul><li>需要动态的给一个对象增加功能，这些功能可以再动态地撤销。</li>
<li>需要增加一些基本功能的排列组合而产生的非常大量的功能。</li></ul>
<h4>题目4</h4>
<p>某系统需要提供一个文件加密模块，加密流程包括：读源文件、加密、保存加密文件。读取文件和保存文件使用流来实现，三个业务相对独立，封装在不同的类中；现在需要提供一个统一的加密外观类，用户可以直接使用该加密外观类完成文件的读取、加密和保存三个操作。使用Facade模式来设计。<br /><br />
<strong>类图设计如下：</strong><br /><br />
<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1249114/201711/1249114-20171110192200903-555604391.png"><br /><br />
<strong>代码实现如下：</strong><br /><br />
a.抽象Facade接口</p>
<pre class="prettyprint linenums"><code>public interface Facade {<br />
	public void Encrypt();<br />
}<br />
</code></pre>
<p>b.文件加密装饰者FacadeEncryptor</p>
<pre class="prettyprint linenums"><code>public class FacadeEncryptor implements Facade{<br />
	private Reader m_read;<br />
	private Saver m_saver;<br />
	private Encryptor m_encryptor;

	public FacadeEncryptor() {<br />
		m_read = new Reader();<br />
		m_saver = new Saver();<br />
		m_encryptor = new Encryptor();<br />
	}

	@Override<br />
	public void Encrypt() {

		m_read.FileReade();<br />
		m_encryptor.FileEncrypt();<br />
		m_saver.FileSave();<br />
	}

}<br />
</code></pre>
<p>c.读取文件类</p>
<pre class="prettyprint linenums"><code>public class Reader {<br />
	public void FileReade()<br />
	{<br />
		System.out.println(&quot;File is reading!&quot;);<br />
	}<br />
}<br />
</code></pre>
<p>d.加密文件类</p>
<pre class="prettyprint linenums"><code>public class Encryptor {<br />
	public void FileEncrypt()<br />
	{<br />
		System.out.println(&quot;File is encrypting!&quot;);<br />
	}

}<br />
</code></pre>
<p>e.保存文件类</p>
<pre class="prettyprint linenums"><code>public class Saver {<br />
	public void FileSave()<br />
	{<br />
		System.out.println(&quot;File is saving!&quot;);<br />
	}

}<br />
</code></pre>
<p>f.测试类</p>
<pre class="prettyprint linenums"><code>public class Client {<br />
	public static void main(String[] args) {<br />
		Facade fac = new FacadeEncryptor();<br />
		fac.Encrypt();<br />
		//File is reading!<br />
		//File is encrypting!<br />
		//File is saving!

	}

}<br />
</code></pre>
<h4>Facade模式小结</h4>
<p>a.优点</p>
<ul><li>对客户屏蔽子系统组件，减少了客户处理的对象数目并使得子系统使用起来更加容易。</li>
<li>实现了子系统与客户之间的松耦合关系。</li>
<li>只是提供了一个访问子系统的统一入口，并不影响用户直接使用子系统类</li></ul>
<p>b.适用场景</p>
<ul><li>需要为一个复杂子系统提供一个简单接口时。</li>
<li>客户程序与抽象类的实现部分之间存在着很大的依赖性。</li>
<li>需要构建一个层次结构的子系统时。</li></ul>
<h4>题目5</h4>
<p>某论坛已注册用户和游客的权限不同，已注册用户拥有发帖、修改自己的注册信息等功能；游客只能看别人的帖子，没有其他权限。使用Proxy模式来设计。<br /><br />
<strong>类图设计如下：</strong><br /><br />
<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1249114/201711/1249114-20171126203829515-1000109393.png"></p>
<p><strong>代码实现如下：</strong><br /><br />
a.抽象用户类</p>
<pre class="prettyprint linenums"><code>public abstract class User {<br />
	public abstract void view();<br />
	public abstract void post();<br />
	public abstract void modify();<br />
}<br />
</code></pre>
<p>b.注册用户类</p>
<pre class="prettyprint linenums"><code>public class realUser extends User{

	@Override<br />
	public void view() {<br />
		System.out.println(&quot;please view nicely!&quot;);

	}

	@Override<br />
	public void post() {<br />
		System.out.println(&quot;please post nicely!&quot;);

	}

	@Override<br />
	public void modify() {<br />
		System.out.println(&quot;please modify rightly!&quot;);

	}

}<br />
</code></pre>
<p>c.游客类</p>
<pre class="prettyprint linenums"><code>public class visitor extends User{<br />
	private User user;

	public visitor(User user)<br />
	{<br />
		this.user=user;<br />
	}

	@Override<br />
	public void view() {<br />
		user.view();<br />
	}

	@Override<br />
	public void post() {<br />
		System.out.println(&quot;please login!&quot;);

	}

	@Override<br />
	public void modify() {<br />
		System.out.println(&quot;please login!&quot;);<br />
	}

}

</code></pre>
<p>d.测试类</p>
<pre class="prettyprint linenums"><code>public class Client {<br />
	public static void main(String[] args) {<br />
		User u1 = new realUser();<br />
		u1.view();//please view nicely!<br />
		u1.post();//please post nicely!<br />
		u1.modify();//please modify rightly!

		u1 = new visitor(u1);<br />
		u1.view();//please view nicely!<br />
		u1.post();//please login!<br />
		u1.modify();//please login!<br />
	}<br />
}

</code></pre>
<h4>Proxy模式小结</h4>
<p>a.优点</p>
<ul><li>代理对象可以在客户端和目标对象之间起到中介的作用，这样起到了中介的作用和保护了目标对象的作用。</li>
<li>真实的角色就是实现实际的业务逻辑，不用关心其他非本职责的事务，通过后期的代理完成一件完成事务，附带的结果就是编程简洁清晰。</li></ul>
<p>b.适用场景</p>
<ul><li>需要为一个对象在不同的地址空间提供局部代表的时候，可以使用远程代理。</li>
<li>需要控制对原始对象的访问的时候，可以使用保护代理。</li>
<li>需要在访问对象执行一些附加操作的时候，可以使用智能指引代理。<br /><br />
需要为一个对象在不同的地址空间提供局部代表的时候，可以使用远程代理。</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2k43lq.html">ASP&period;NET SessionState 解惑</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j3y4lq.html">『创意欣赏』20款精致的 iOS7 APP 图标设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wk03xq.html">JqueryMobile动态生成listView并实现刷新的两种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydjy5dq.html">java 线程&ZeroWidthSpace;基本概念 可见性 同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy11glgq.html">2014在百度之星程序设计大赛 - 资格 第四个问题 Labyrinth</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyjr2z9.html">webpack使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zonpkxq.html">Python实现PPPOE攻击工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jlllv8.html">Spring-mvc设置&commat;RequestMapping标签更改返回头及&commat;RequestMapping简述</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzw10g8.html">Linux查看系统、核数、CPU、位数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rpmn48.html">如何写一个通用的README规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25mnxlq.html">&lbrack;译&rsqb;使用Command模式和MediatR简化你的控制器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwovpz9.html">Scala学习教程笔记三之函数式编程、集合操作、模式匹配、类型参数、隐式转换、Actor、</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zylpwd9.html">Unable to load DLL &amp;&num;39&semi;SQLite&period;Interop&period;dll&amp;&num;39&semi;&colon; The specified module could not be found&period; &lpar;Exception from HRESULT&colon; 0x8007007E&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o10o1pq.html">QT开发基础教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj0x5zq.html">MFC 如何为控件关联变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1mrd09.html">【LOJ】&num;2496&period; 「AHOI &sol; HNOI2018」毒瘤</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pyr708.html">细说Request与Request&period;Params</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlj6zy9.html">JavaScript String 对象常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vr662q.html">微信小程序&colon;冒泡事件及其阻止</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmlxlw9.html">python学习笔记6-集合</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlj2dv19.html">tomcat原理（一）server&period;xml中的host虚拟主机的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj2dg09.html">为你揭露2018微信公开课pro的12个重点</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pknlv8.html">用python帮朋友刷帖</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdyoz79.html">【NOIP2015】斗地主（搜索，贪心）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey7nde9.html">解决Win10下&lowbar;findnext&lpar;&rpar;异常</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj2yo69.html">封装Jquery 合并table中任何同列数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjkrl38.html">iOS加密算法总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojpnnxq.html">jquery ajax 返回的json对象 新增属性值（干货）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1komy29.html">WordCount程序代码解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1p56jq.html">二分查找&lpar;Java实现&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
